#!/usr/bin/python3

# -*- coding: utf-8 -*-
# (k) made-on-the-knee-of /dragon, 2017

import os,sys,logging,json
import time
from datetime import datetime, timedelta

from random import random
from binfs import *
    
cf = json.load(open('_unit.json'))

log = logging.getLogger('Test binfs')
log.setLevel(logging.DEBUG)
lh = logging.StreamHandler()
lh.setFormatter(logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s'))
log.addHandler(lh)
log.info("Begin")

btime = time.time()


b = binfs(
    name = cf['name'], 
    root = cf['root'], 
    oCreate = True, oTruncate = False, 
    setUID = cf['setuid'] if 'setuid' in cf else None, 
    setGID = cf['setgid'] if 'setgid' in cf else None )
b.setlogger(log.getChild(cf['name']))

def  _usage():
    print(("""
        %s 
            load <n=50k> <from=*(last key)>
            stat
            restat
            purge
            get
            drop <key>
            clean <interval from now()>
    """ % (sys.argv[0])))

if len(sys.argv) > 1:
    if sys.argv[1] == 'load':
        n = 50000
        try:
            if len(sys.argv) > 2:
                n = int(sys.argv[2])
        except:
            pass
        with open(cf['bin'],'rb') as binfile:
            bin = binfile.read()
        tstart = int((datetime.now() - datetime.fromtimestamp(0)).total_seconds() * 1e6)
        tdelta = int(120*1e6)
        tvar = 10000
        try:
            if len(sys.argv) > 3:
                if sys.argv[3] == "*":
                    s = b._currentstat()
                    tstart = int(float(_s['pathmin'])*1e6)
                else:    
                    tstart = int(sys.argv[3])
        except:
            pass        
        t = tstart
        for i in range(n):
            meta = {"t": t}
            r = b.save(t, bin)
            print(("%s -> %s" % (t,r)))
            b.meta_set(t,json.dumps(meta))
            t = int(t - tdelta + tvar*random())
    elif sys.argv[1] == 'stat':
        print((str(b._currentstat())))
    elif sys.argv[1] == 'restat':
        b.restat()
        print((str(b._currentstat())))
    elif sys.argv[1] == 'purge':
        r = b.purge()
        print(("Purge: " + str(r)))
    elif sys.argv[1] == 'get':
        t = int(sys.argv[2])
        with open('res.bin','wb') as ofile:
            ofile.write(b.load(t))    
        print(("bin: " + str(os.stat('res.bin'))))
        print(("meta: " + str(b.meta_get(t))))
    elif sys.argv[1] == 'drop':
        t = int(sys.argv[2])
        print(("drop bin: " + str(b.drop(t))))
        print(("drop meta: " + str(b.meta_drop(t))))
    elif sys.argv[1] == 'clean':
        t = parse_interval(sys.argv[2])
        r = b.clean(None,datetime.now()-t)
        print(("CLEAN: %s " % (r)))
        b.restat()
        print((b._currentstat()))
    else:
        _usage()
else:
    _usage()
log.info("End")        
log.info("Elapsed time: %s" % (time.time()-btime))
