create or replace function acs.postfactum_event_access(new public.eventstore, out _errcode integer, out _errmsg varchar) as $$
declare
    _o uuid;
    _d text;
    _l text;
    _r record;
begin
    _errcode := 0; _errmsg := 'OK';
    
    _o := (new.event #>> '{origin,uuid}')::uuid ;
    _l := new.event #>> '{measurements,0,waypoints,best,location,lane}'; 
    _d := new.event #>> '{measurements,0,waypoints,best,vehicle,dir}';


    insert into acs.crossing
        (port,fromzone,tozone,guid,ctime,plate)
        select 
            p.name as port,
            p.fromzone,
            p.tozone,
            (new.event ->> 'uuid')::uuid as guid,
            (new.event ->> 'time')::timestamptz as ctime,
            new.event #>> '{measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}' as plate
        from acs.ports p
        where
            p.origin = _o and
            (p.lane = '*' or p.lane = _l) and
            (p.direction = '*' or p.direction = _d)
        limit 1;
    
    if not found then
        _errcode := -1; _errmsg = 'Port not found';
        return;
    end if;
end;
$$ language plpgsql;

