create table if not exists acs.crossing (
    port varchar(256) not null,
    fromzone int not null,
    tozone int not null,
    guid uuid not null,
    ctime timestamptz not null,
    plate varchar(128),
    next uuid,
    prev uuid,
    flag int not null default 0
);


alter table acs.crossing alter column port set storage plain;
alter table acs.crossing alter column plate set storage plain;

DO $$
BEGIN
IF to_regclass('acs.i_crossing_port') IS NULL THEN
    CREATE  INDEX i_crossing_port ON acs.crossing USING btree (port);
END IF;
IF to_regclass('acs.i_crossing_fz') IS NULL THEN
    CREATE  INDEX i_crossing_fz ON acs.crossing USING btree (fromzone);
END IF;
IF to_regclass('acs.i_crossing_tz') IS NULL THEN
    CREATE  INDEX i_crossing_tz ON acs.crossing USING btree (tozone);
END IF;
IF to_regclass('acs.i_crossing_id') IS NULL THEN
    CREATE  INDEX i_crossing_id ON acs.crossing USING btree (guid);
END IF;
IF to_regclass('acs.i_crossing_ts') IS NULL THEN
    CREATE  INDEX i_crossing_ts ON acs.crossing USING btree (ctime);
END IF;
IF to_regclass('acs.i_crossing_plate') IS NULL THEN
    CREATE  INDEX i_crossing_plate ON acs.crossing USING btree (plate COLLATE pg_catalog."default");
END IF;
IF to_regclass('acs.i_crossing_next') IS NULL THEN
    CREATE  INDEX i_crossing_next ON acs.crossing USING btree (next);
END IF;
IF to_regclass('acs.i_crossing_prev') IS NULL THEN
    CREATE  INDEX i_crossing_prev ON acs.crossing USING btree (prev);
END IF;
IF to_regclass('acs.i_crossing_flag') IS NULL THEN
    CREATE  INDEX i_crossing_flag ON acs.crossing USING btree (flag);
END IF;
END$$;


