create or replace function binfs.prepare( filepath text, imkdir boolean default true, iremove boolean default true ) returns integer as $$
import os

try:
    if os.path.exists(filepath):
        if iremove:
            os.remove(filepath)
        return 1
    folder = os.path.dirname(filepath)
    if not os.path.exists(folder):
        oldumask = os.umask(0)
        os.makedirs(folder)
        os.umask(oldumask)
    return 0
except Exception as ex:
    plpy.execute("select core.log('binfs.prepare','error','prepare: '||{0})"
                 .format(plpy.quote_nullable(str(ex))))
    return -1
$$ language plpython3u;

create or replace function binfs.exists( filepath text ) returns integer as $$
import os

try:
    if os.path.exists(filepath):
        return 1
    return 0    
except Exception as ex:
    plpy.execute("select core.log('binfs.exists','error','exists: '||{0})"
                 .format(plpy.quote_nullable(str(ex))))
    return -1
$$ language plpython3u;


create or replace function binfs.rm( filepath text ) returns integer as $$
import os

try:
    if os.path.isfile(filepath):
        os.remove(filepath)
        return 1
    return 0
except Exception as ex:
    plpy.execute("select core.log('binfs.rm','error','exists: '||{0})"
                 .format(plpy.quote_nullable(str(ex))))
    return -1
$$ language plpython3u;

