create or replace function binfs.save(istore varchar, ikey anyelement, idata bytea, iower boolean default true) returns integer as $$
declare
	res integer;
	path text;
begin
	select into path binfs.path(istore,ikey);
	if path isnull then
		return -1;
	end if;
	select into res binfs.prepare(path,true,iower);
	if res < 0 then
		return -1;
	end if;
	if res > 0 and not iower then
		perform core.log('binfs.save','error','atom already exists: '||ikey::text||' @ '||istore);
		return -1;	
	end if;	
	select into res lib.bytea_save(idata, path);
	return res;
end;
$$ language plpgsql;	
