
create or replace function core.jsetopt( iopt json ) returns integer as $$
	select sum(cnt)::integer from (
		select core.setopt(section,key,value) as cnt from (
			select * from json_to_recordset( $1->'opt') as t(section text, key text, value text)
		) q
	) qq;
$$ language sql;	


create or replace function core.loadopt_d( ipath text, imask text default '*.conf' ) returns integer as $$
import codecs
import glob
import json
import os

psetopt = plpy.prepare('select core.setopt($1,$2,$3) as res',
                       ['text','text','text'])
r = 0
try:
    for filename in sorted(glob.glob(os.path.join(ipath, imask))):
        dopt = json.load(codecs.open(filename, 'r', encoding='utf-8'))
        for opt in dopt['opt']:
            rv = plpy.execute(psetopt,[opt['section'], opt['key'],
                                       opt['value']], 1)
            if rv.nrows() > 0:
                r += rv[0]['res']
except Exception as ex:
    plpy.execute("select core.log('core.loadopt','error','opt: '||{0})"
                 .format(plpy.quote_literal(str(ex))))
    return None
return r
$$ language plpython3u;


