CREATE unlogged TABLE if not exists core.varlog
(
  moment timestamp with time zone NOT NULL DEFAULT now(),
  facility character varying(256) NOT NULL,
  severity character varying(32) NOT NULL,
  body text
);

DO $$
BEGIN
IF to_regclass('core.core_varlog_facility') IS NULL THEN
    CREATE INDEX core_varlog_facility ON core.varlog USING btree (facility COLLATE pg_catalog."default");
END IF;
IF to_regclass('core.core_varlog_moment') IS NULL THEN
    CREATE INDEX core_varlog_moment ON core.varlog USING btree (moment);
END IF;
END$$;
