create or replace function hwp.watchsweep(
    tbl varchar,
    sha1 varchar,
    revision varchar,
    dovcs boolean default true,
    out inserted int,
    out deleted int,
    out updated int
) as $$
declare
    r record;
begin
inserted := 0;
deleted := 0;
updated := 0;
    for r in execute format('select * from %I where op notnull',tbl) loop
        case r.op
            when -1 then
                delete from only hwp.watchlistitems where owner = r.owner and ident = r.ident and plate = r.plate;
                deleted := deleted + 1;
            when 0 then
                update only hwp.watchlistitems set class=r.class, color=r.color, make=r.make, model=r.model, alarm=r.alarm, memo=r.memo, meta=r.meta where owner = r.owner and ident = r.ident and plate = r.plate;
                updated := updated + 1;
            when 1 then
                insert into hwp.watchlistitems values(r.owner,r.ident,r.plate,r.class,r.color,r.make,r.model,r.alarm,r.memo,r.meta);
                inserted := inserted + 1;
        end case;
        if dovcs then
            insert into hwp.watchlistvcs values(r.op,r.optime,revision,sha1,r.owner,r.ident,r.plate,r.class,r.color,r.make,r.model,r.alarm,r.memo,r.meta);
        end if;    
    end loop;
end;
$$ language plpgsql;


