create or replace function lib.geoformat( igg public.geodata, itag varchar ) returns varchar as $$
declare
	str varchar;
	alat float8;
	alon  float8;
	clat char(1);
	clon  char(1);
begin
	clat := case when igg.latitude >= 0 then 'N' else 'S' end; 
	clon := case when igg.longitude >= 0 then 'E' else 'W' end; 
if itag = 'dms' then
	alat := abs(round(igg.latitude * 1e6 )); 
	alon := abs(round(igg.longitude * 1e6 )); 
	if igg isnull or igg.latitude isnull or igg.longitude isnull then
		str := E'--°--\'------"N --°--\'------"E';
	else	
		str :=
			(floor(alat/1e6))::text || E'\u00b0' ||
			floor(((alat/1e6) - floor(alat/1e6))*60)::text || '''' ||
			to_char(floor((((alat/1e6) - floor(alat/1e6))*60 - floor(((alat/1e6) - floor(alat/1e6))*60))*1e5)*60/1e5,'FM00.00')::text || '"' || clat
		||' '||
			(floor(alon/1e6))::text || E'\u00b0' ||
			floor(((alon/1e6) - floor(alon/1e6))*60)::text || '''' ||
			to_char(floor((((alon/1e6) - floor(alon/1e6))*60 - floor(((alon/1e6) - floor(alon/1e6))*60))*1e5)*60/1e5,'FM00.00')::text || '"' || clon
		;
	end if;
elsif itag = 'dd' then
	if igg isnull or igg.latitude isnull or igg.longitude isnull then
		str := E'--.------N--.------E';
	else	
		str := to_char(abs(igg.latitude)/1e6,'FM00.000000')||clat || to_char(abs(igg.longitude),'FM00.000000')||clon;
	end if;	
else
	str := '';
end if;	
return str;
end;
$$ language plpgsql;

