
create or replace function lib.json_path_get( idata json, ipath text ) returns json as $$
import json
import re

dic = json.loads(idata)
for pth in re.split('[\/\[\]]', ipath):
    if pth:
        if pth in dic:
            dic = dic[pth]
        else:
            return None
return json.dumps(dic)
$$ language plpython3u;


create or replace function lib.json_path_set ( idata json, ipath text, ipart json, icreate boolean default true ) returns json as $$
import json
import re

def _get(dic, path, mk):
    for pth in re.split('[\/\[\]]', path):
        if pth:
            if not (type(dic) in (dict, tuple, list)):
                return None
            if pth in dic:
                dic = dic[pth]
            else:
                if mk:
                    dic[pth] = {}
                    dic = dic[pth]
                else:
                    return None
    return dic

dic = json.loads(idata)
part = json.loads(ipart)
path = re.split('[\/\[\]]', ipath)
key = path[-1]
ddic = _get(dic, ipath[:(ipath.rfind(key) - 1)], icreate)
if ddic is not None and type(ddic) in (dict, tuple, list):
    ddic[key] = part
return json.dumps(dic)
$$ language plpython3u;


