

CREATE or replace FUNCTION lib.slur(i_media bytea, i_vertex text, i_inverse boolean DEFAULT true, i_crop boolean DEFAULT false, i_slur boolean DEFAULT true) RETURNS public.cropresult
    LANGUAGE plpython3u
    AS $$
import cStringIO

from PIL import Image, ImageChops, ImageDraw

try:
    ims = Image.open(cStringIO.StringIO(i_media))
    (ims_w, ims_h) = ims.size
except:
    return None
imres = ims
(t2a, t2b, t2c, t2d, t2x, t2y) = (1, 0, 0, 1, 0, 0)
try:
    vx = eval(i_vertex)
except:
    return None
if len(vx) < 1:
    return None
if "." in i_vertex:
    for i, v in enumerate(vx):
        for j, p in enumerate(v):
            vx[i][j] = (int(p[0] * ims_w), int(p[1] * ims_h))
if i_slur:
    imblack = Image.new(ims.mode, ims.size)
    (mbg, mfg) = (0, 1) if i_inverse else (1, 0)
    imask = Image.new("1", ims.size, mbg)
    dmask = ImageDraw.Draw(imask)
    for i, v in enumerate(vx):
        dmask.polygon(v, mfg)
    imres = Image.composite(ims, imblack, imask)
if i_crop:
    (ml, mt, mr, mb) = (ims_w - 1, ims_h - 1, 0, 0)
    for i, v in enumerate(vx):
        for j, p in enumerate(v):
            if p[0] < ml:
                ml = p[0]
            if p[0] > mr:
                mr = p[0]
            if p[1] < mt:
                mt = p[1]
            if p[1] > mb:
                mb = p[1]
    imres = imres.crop((ml, mt, mr, mb))
    (t2x, t2y) = (ml, mt)
t = cStringIO.StringIO()
imres.save(t, "JPEG")
tr = '(%(a)f , %(b)f , %(c)f , %(d)f , %(x)f , %(y)f)' % {"a": t2a,
                                                          "b": t2b,
                                                          "c": t2c,
                                                          "d": t2d,
                                                          "x": t2x,
                                                          "y": t2y}
return {"data": t.getvalue(), "transform": tr}
$$;

CREATE or replace FUNCTION lib.slur(i_media bytea, i_vertex text, i_inverse boolean DEFAULT true, i_crop boolean DEFAULT false) RETURNS public.cropresult
    LANGUAGE plpython3u
    AS $$
import cStringIO

from PIL import Image, ImageChops, ImageDraw

try:
    ims = Image.open(cStringIO.StringIO(i_media))
    (ims_w, ims_h) = ims.size
except:
    return None
try:
    vx = eval(i_vertex)
except:
    return None
if len(vx) < 1:
    return None
if "." in i_vertex:
    for i, v in enumerate(vx):
        for j, p in enumerate(v):
            vx[i][j] = (int(p[0] * ims_w), int(p[1] * ims_h))
imblack = Image.new(ims.mode, ims.size)
(mbg, mfg) = (0, 1) if i_inverse else (1, 0)
imask = Image.new("1", ims.size, mbg)
dmask = ImageDraw.Draw(imask)
for i, v in enumerate(vx):
    dmask.polygon(v, mfg)
imres = Image.composite(ims, imblack, imask)
(t2a, t2b, t2c, t2d, t2x, t2y) = (1, 0, 0, 1, 0, 0)
if i_crop:
    (ml, mt, mr, mb) = (ims_w - 1, ims_h - 1, 0, 0)
    for i, v in enumerate(vx):
        for j, p in enumerate(v):
            if p[0] < ml:
                ml = p[0]
            if p[0] > mr:
                mr = p[0]
            if p[1] < mt:
                mt = p[1]
            if p[1] > mb:
                mb = p[1]
    imres = imres.crop((ml, mt, mr, mb))
    (t2x, t2y) = (ml, mt)
t = cStringIO.StringIO()
imres.save(t, "JPEG")
tr = '(%(a)f , %(b)f , %(c)f , %(d)f , %(x)f , %(y)f)' % {"a": t2a,
                                                          "b": t2b,
                                                          "c": t2c,
                                                          "d": t2d,
                                                          "x": t2x,
                                                          "y": t2y}
return {"data": t.getvalue(), "transform": tr}
$$;
