drop function if exists public.transform(i_section text, i_source text);
CREATE OR REPLACE FUNCTION public.transform(i_section text, i_source text, i_mindepth integer default 0) RETURNS text
    LANGUAGE plpgsql
    AS $_$
declare
    i       integer;
    r       record;
    str     text;
begin
    i := 0;
    str := i_source;
    for r in select * from public.transformations where exists ( select true from  public.transformations where section = i_section ) and i_section ~ (E'^'||section||E'(\.|$)') order by section, priority loop
        i := i + 1;
        if i <= i_mindepth then
            continue;
        end if;    
        if 		r.flag ~ E'^translate' then
        	str := translate(str, r.regex, r.replace);
        elsif	r.flag ~ E'^itranslate' then 
        	str := translate(str, upper(r.regex)||lower(r.regex), upper(r.replace)||lower(r.replace));
        elsif	r.flag ~ E'^trim' then 
			if 		r.replace = E'left' then
				if r.regex notnull and r.regex <> E'' then str := ltrim(str, r.regex); else str := ltrim(str); end if;
			elsif	r.replace = E'right' then
				if r.regex notnull and r.regex <> E'' then str := rtrim(str, r.regex); else str := rtrim(str); end if;
			elsif	r.replace = E'both' then
				if r.regex notnull and r.regex <> E'' then str := btrim(str, r.regex); else str := btrim(str); end if;
			end if;
		else
        	str := regexp_replace(str, r.regex, r.replace, r.flag);
        end if;
    end loop;
    return str;
end;
$_$;

